//supporting websocket
if (!window.WebSocket) {
    alert("WebSocket not supported by this browser!");
}

function showLogin() {
    var loginDiv = document.getElementById("login_div");
    var logoDiv = document.getElementById("logo_div");
    var clientx = document.documentElement.clientWidth;
    var clienty = document.documentElement.clientHeight;
    var l_margin = (clientx - parseInt(loginDiv.style.width)) / 2;
    var logo_l_margin = (clientx - parseInt(logoDiv.style.width)) / 2;
    var t_margin = (clienty - parseInt(loginDiv.style.height) - 200) / 2
    loginDiv.style.left = l_margin + "px";
    logoDiv.style.left = logo_l_margin + "px";
    loginDiv.style.top = t_margin +"px";
    loginDiv.style.display = "block";

    document.getElementById('login').focus();
    
    var user = document.getElementById("user");
    user.value = "admin";

    setupSocket();
}

function titleMove() {
    var moveable = true;
    var loginDiv = document.getElementById("login_div");
    var clientX = window.event.clientX;
    var clientY = window.event.clientY;
    var moveTop = parseInt(loginDiv.style.top);
    var moveLeft = parseInt(loginDiv.style.left);
    document.onmousemove = function MouseMove() {
        if (moveable) {
            var y = moveTop + window.event.clientY - clientY;
            var x = moveLeft + window.event.clientX - clientX;
            if (x > 0 && y > 0) {
                loginDiv.style.top = y + "px";
                loginDiv.style.left = x + "px";
            }
        }
    }
    document.onmouseup = function Mouseup() {
        moveable = false;
    }
}

//Socket open callback
function socketOpened()
{
    //do nothing
}

//At the same time, just send only two message to server!
function handleData(data)
{
    var vals    = data.split("\t");
    var msgType = vals[0];
   
    console.log(data);
        
    var ack = JSON.parse(data);

    if (ack && ack.ack && ack.ack.cmd)
    {
        if (ack.ack.cmd.indexOf("config set login") >= 0)
        {
            //console.log(ack.ack.status);
            if (ack.ack.status != "success")
            {
                 alert("Invalid Username or Password"); // 05222018 FangDa added to display error message
                
                return;
            }
            else
            {
                //complete_message("Login success!");

                window.location.href = "main.html";
            }
        }

        //console.log(ack.ack.cmd +" return "+ ack.ack.status);
    }
}

function login_apply()
{
    var user = document.getElementById("user");
    var pass = document.getElementById("pass");

    var cmd = "config set login ";
        cmd += user.value;
        cmd += " ";
        cmd += pass.value;
        cmd += ";";

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
    }
}
