//supporting websocket
if (!window.WebSocket)
{
    alert("WebSocket not supported by this browser!");
}

document.onmousewheel = function() { if(event.ctrlKey) return false; }

//Socket open callback
function socketOpened()
{
    //test only
    //var cmd = "config set login admin;";
    //if (ws)
    //{
    //    ws.doSend(cmd);
    //    console.log("main.js: " + cmd);
    //}

    //sleep(1000);

    ///// Talk with server!
    cmd  = "config get login;config get webversion info;";
    cmd += "config get vs usermode;";
    cmd += "config get controller master ";

    var hostip = document.location.host;
    if (!hostip) hostip = "127.0.0.1";

    cmd += hostip;
    cmd += ";";

    cmd += "config get devlist;config get ipsources;";
    cmd += "config get winmodes;";

    if (ws)
    {
        ws.doSend(cmd);
        console.log("main.js: " + cmd);
    }
}

function handleData(data)
{
    var ack = JSON.parse(data);

    if (ack && ack.ack)
    {
        if (ack.ack.cmd == "config get login")
        {
            if (ack.ack.status != "success")
            {
                //error_message("no login!");

                window.location.href = "index.html";
                
                return;
            }
            else
            {
                var cmd = "config get devlist;config get ipsources;";

                if (ws)
                {
                    ws.doSend(cmd);
                    //console.log("main.js: " + cmd);
                }

                return;
            }
        }
        else
        {
            //console.log(ack.ack.cmd +" return "+ ack.ack.status);
        }
    }

    handleData_Channel(data);
    handleData_Windows(data);
    handleData_Modes(data);
    handleData_wall(data);
    handleData_Setup(data);
    handleData_Update(data);
}

//page loaded
function mainload()
{
    setupSocket();

    //init channel UI
	initChannelsUI();

    //init Window UI
    initWindowsUI();

    //init Mode UI
    initModesUI();

    //init Setup UI
    initSetupData();
	
    initUpdateData();
}

function logout()
{
    var cmd = "config set logout";

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
    }

    window.location.href = "index.html";    
}
