//define Model Class

//current mode max
var modeactivemax = 4;
var modemax = 8;

function handleData_Modes(data)
{
    var vals    = data.split("\t");
    var msgType = vals[0];
   
    //console.log(data);
        
    var ack = JSON.parse(data);

    if (ack && ack.winmode)
    {
        resetModelData();

    	var i = 0;
    	for (var dev in ack.winmode)
    	{
    		var winmode = ack.winmode[i ++];

    	    var name = winmode.modename;
    	    var id = winmode.modeid;
    	    var active = winmode.modeactive;
    	    var max = winmode.modemax;

    	    modeactivemax = active;
    	    modemax = max;

            addModelData(id, name);
        }

        if (i != modemax)
        {
            console.log("something wrong with win mode!");
        }

        console.log("winmode info: " + i + ", " + active + ", " + max);    	

        BuildModes();
    }
    else if (ack && ack.ack && ack.ack.cmd)
    {
        if (ack.ack.cmd.indexOf("config set load winmode") > -1)
        {
        	//reload window
        	close(); //close loading mode
            window.location.href = "main.html";
        }
    }
};

function Model(index,name,state)
{
	this.index = index;
	this.name = name;
	this.state = state;

	this.savemodel = function (index,name) {
		if(index > modemax)
			return false;
		else
		{
			this.index = index;
			this.name = name;
			this.state = true;
		}
	}

	this.loadmodel = function(index)
	{
		if (index < modemax)
		{
			if(state)
				return true;
			else
				return false;
		}
		else
		{
			return false;
		}
	}
};

var addModelData = function(id, name)
{
	var model;

	if (id < modeactivemax)
	{
        model = new Model(id + 1, name, true);
	}
	else
	{
        model = new Model(id + 1, "Model", false);
	}
	modellist.push(model);
}

//Send command to server to get model info
var modellist;
var initModelData = function() {

    //var tbmode = document.getElementById("tbmode");
    //tbmode.style.visibility = "hidden"; //"visible";

    //var btn = document.getElementById('AddModel');
    ///btn.style.visibility = "hidden";

    //var modesmanagement = document.getElementById('modesmanagement');
    //modesmanagement.style.visibility = "hidden";
}

function resetModelData() {
    modellist = null;

    modellist = new Array();	
}

function refreshModelUI(tb, colnum, addModel) {

	//var del = tb.getElementsByTagName('a');
	//var span = tb.getElementsByTagName('span');
	//var ctr=[];/* save tr object */

	var removeEvent = function(){
		var id = this.id.split("e")[2];

        var length = modellist.length;
        for (var i = 0; i < length; i ++)
        {
		    modellist.shift();
		}

        del_mode(id);
 	};

	var loadEvent = function(){
		//var dder = this.parentNode.parentNode;
		//console.log("Load Model Index:" + dder.children[0].firstChild.nodeValue);
		var id = this.id.split("d")[1];
		load_mode(id);
	};

	var saveEvent = function(){
		//var sder = this.parentNode.parentNode;
		//console.log("Load Model Index:"+ sder.children[0].firstChild.nodeValue);
		//
		var id = this.id.split("e")[1];
		//alert(id);
		var modeName = document.getElementById("modeName" + id);
		//alert(modeName.innerHTML); 
		save_mode(id, modeName.innerHTML);
	};

	var spanEvent = function(){/* edit control! */
		var value = this.firstChild.nodeValue;
		var input = document.createElement('input');
        var id = this.id.split('e')[2];

		input.value = value;
		input.maxLength="8"; // '8';
		this.parentNode.appendChild(input);
		this.parentNode.removeChild(this);

		input.focus();
		input.onkeyup = function () {
                    if (event.keyCode == 13)
                    {
                        input.blur();
                    }
		};
		input.onblur = function() {/* remove control when focus lost! */
	        if (input.value == "")
	        {
	            alert("Invalid Name!");
	            input.value = value;

	            return;
	        }
			
            //save model name!
            modellist[id].name = input.value;

			var span = document.createElement('span');
			span.appendChild(document.createTextNode(this.value?this.value:'null'));
			span.onclick = spanEvent;
			this.parentNode.appendChild(span);
			this.parentNode.removeChild(this);

			if (value != this.value){
				save_mode(id, this.value);
			}
			refreshTabaleData();
		}
	};

	window.onbeforeunload = function(){
	};
};

/* called when html page loaded! */
function initModesUI()
{	
    console.log("mode page load");	
};

function BuildModes()
{
	var modes = document.getElementById('modes');

	// modes.innerHTML = "";

	var btnAddModel = document.getElementById('AddModel');/* add button */

    //Build Model UI
	refreshModelUI(modes, 3, btnAddModel);	
}

function add_mode(name)
{
	if (name && name.length > 16) name = name.slice(0, 16);

	var cmd = "config set add winmode ";
	    cmd += name;

	if (ws)
	{
        ws.doSend(cmd);
        console.log(cmd);
    }
}

function save_mode(index, name)
{
	if (name && name.length > 16) name = name.slice(0, 16);

	var cmd = "config set modify winmode ";
	cmd += index;
	cmd += " byIndex ";	// cmd += " ";
	cmd += name;

	if (ws)
	{
        ws.doSend(cmd);
        console.log(cmd);
    }
}

function load_mode(index)
{
    //talk to window.js
    //window.html is 2 of frameset
    
	var cmd = "config set load winmode ";
	    cmd += index;
	    cmd += " byIndex";

	if (ws)
	{
        ws.doSend(cmd);
        console.log(cmd);
    }

    showLoader("Load mode data...");
}

function del_mode(index)
{
	//del winmode and re-load winmodes
	var cmd = "config set del winmode ";
	    cmd += index;
	    cmd += " byIndex";
	    cmd += ";config get winmodes;"

	if (ws)
	{
        ws.doSend(cmd);
        console.log(cmd);
    }
}
