//util.js
//add 0 before value to make value
function p0(s) 
{
    return s < 10 ? '0' + s: s;
}

function sleep(ms) {
    var unixtime_ms = new Date().getTime();
    while(new Date().getTime() < unixtime_ms + ms) {}
}

//get time
function getTime()
{
    var thisDate = new Date();  
    var thisTimeString = p0(thisDate.getHours()) + ":" + p0(thisDate.getMinutes())+":"+p0(thisDate.getSeconds());

    return thisTimeString; 
}

function GetMessageString(sMsg, sSub) {
    var re = new RegExp(sSub + "=([^//&]*)", "i");
    var a = re.exec(sMsg);

    if (a == null)
        return "";

    return a[1];
}

//get the special value from string 
function GetQueryString(sProp) {
    var re = new RegExp("[&,?]" + sProp + "=([^//&]*)", "i");
    var a = re.exec(document.location.search);
    if (a == null)
        return "";

    return a[1];
}

function isMobileBrowser()
{
    var sUserAgent = navigator.userAgent.toLowerCase();

    var bIsIphoneOs = sUserAgent.match(/iphone os/i) == "iphone os";
    var bIsIpad = sUserAgent.match(/ipad/i) == "ipad";
    var bIsMidp = sUserAgent.match(/midp/i) == "midp";
    var bIsUc7 = sUserAgent.match(/rv:1.2.3.4/i) == "rv:1.2.3.4";
    var bIsUc = sUserAgent.match(/ucweb/i) == "ucweb";
    var bIsAndroid = sUserAgent.match(/android/i) == "android";
    var bIsCE = sUserAgent.match(/windows ce/i) == "windows ce";
    var bIsWM = sUserAgent.match(/windows mobile/i) == "windows mobile";
    
    if (bIsIphoneOs || bIsIpad || bIsMidp || bIsUc7 || bIsUc || bIsAndroid || bIsCE || bIsWM)
    {
        return true;
    }
    else
    {
        return false;
    }
}

function isNumber(str)
{
    if (str.length == 0)
    {
        return false;
    }
    for (var i = 0; i < str.length; i++)
    {
       if (str.charAt(i) < "0" || str.charAt(i) > "9")
       {
           return false;
       }
    }

    return true;
}

function checkIPValid(addr, ip_netmask_gw) // 0 :ip  1: netmask;  2: gateway
{
    var part_addr = addr.split(".");
    
    if (part_addr.length != 4) 
    {
        return false;
    }
    else 
    {
        var part;
        
        for (part in part_addr) 
        {
            if (isNumber(part_addr[part])) 
            {
                if (parseInt(part_addr[part]) < 0 || parseInt(part_addr[part]) > 255) 
                {
                    if(ip_netmask_gw == 0)
                    {
                        alert("ipaddress: " + addr + " is not valid!");
                    }
                    else if(ip_netmask_gw == 1)
                    {
                        alert("netmask: " + addr + " is not valid!");
                    }
                    else if(ip_netmask_gw == 2)
                    {
                        alert("gateway: " + addr + " is not valid!");
                    }
					
                    return false;
                }
            }
            else 
            {
                if(ip_netmask_gw == 0)
                {
                    alert("ipaddress: " + addr + " is not valid!");
                }
                else if(ip_netmask_gw == 1)
                {
                    alert("netmask: " + addr + " is not valid!");
                }
                else if(ip_netmask_gw == 2)
                {
                    alert("gateway: " + addr + " is not valid!");
                }

                return false;
            }
        }
    }
}

function detectZoom() { 
    var ratio = 0,
        screen = window.screen,
        ua = navigator.userAgent.toLowerCase();
    if( ~ua.indexOf('firefox') ){
        if( window.devicePixelRatio !== undefined ){
            ratio = window.devicePixelRatio;
        }
    }
    else if( ~ua.indexOf('msie') ){    
        if( screen.deviceXDPI && screen.logicalXDPI ){
            ratio = screen.deviceXDPI / screen.logicalXDPI;
        }
    }
    else if( window.outerWidth !== undefined && window.innerWidth !== undefined ){
        ratio = window.outerWidth / window.innerWidth;
    }
    
    if( ratio ){
        ratio = Math.round( ratio * 100 );
    }
    
    // for 360 browser only!
    if( ratio === 99 || ratio === 101 ){
        ratio = 100;
    }
    
    return ratio;
};