var curselectvideowallid = -1;
var name = "";
var horizontal = 1;
var vertical = 1;
var horizontalcut = 1;
var vertialcut = 1;
var curpreset;
var curusedvideowallid = -1;

function handleData_wall(data)
{
    var vals    = data.split("\t");
    var msgType = vals[0];
   
    //console.log(data);
        
    var ack = JSON.parse(data);
    if (ack && ack.sceneinfo)
    {
    	var i = 0;
    	for (var dev in ack.sceneinfo)
    	{
    	    var sceneInfo = ack.sceneinfo[0];

            curselectvideowallid = sceneInfo.sceneid;
    	    name = sceneInfo.scenename;
    	    curpreset = sceneInfo.scenecurpreset;
    	    horizontal = sceneInfo.scenerows;
    	    vertical = sceneInfo.scenecolumns;
    	    horizontalcut = sceneInfo.scenehorcut;
    	    vertialcut = sceneInfo.scenevercut;
			
    	    document.getElementById('wallname').value = name;
    	    document.getElementById('horinput').value = horizontal;
    	    document.getElementById('verinput').value = vertical;
    	    document.getElementById('horcutinput').value = horizontalcut;
    	    document.getElementById('vercutinput').value = vertialcut;
    	    if((curpreset>=1) && (curpreset<=3)){
    	        document.getElementById('preset').options[curpreset-1].selected = true;
    	    }
        }

    }
};

function setup(id){
	document.getElementById('horinput').value = horizontal;
	document.getElementById('verinput').value = vertical;
	document.getElementById('horcutinput').value = horizontalcut;
	document.getElementById('vercutinput').value = vertialcut;

	if(id == 'horup'){
		var value = parseInt(document.getElementById('horinput').value);
		if(value+1 >4){
			return;
		}
		horizontal= value+1;
		$("#horinput").val(horizontal);
	}else if(id == 'verup'){
		var value = parseInt(document.getElementById('verinput').value);
		if(value+1 >4){
			return;
		}
		vertical= value+1;
		$("#verinput").val(vertical);
	}else if(id == 'horcutup'){
		var value = parseInt(document.getElementById('horcutinput').value);
		if(value+1 >8){
			return;
		}
		horizontalcut= value+1;
		$("#horcutinput").val(horizontalcut);
	}else if(id == 'vercutup'){
		var value = parseInt(document.getElementById('vercutinput').value);
		if(value+1 >8){
			return;
		}
		vertialcut= value+1;
		$("#vercutinput").val(vertialcut);
	}
}

function setdown(id){
	document.getElementById('horinput').value = horizontal;
	document.getElementById('verinput').value = vertical;
	document.getElementById('horcutinput').value = horizontalcut;
	document.getElementById('vercutinput').value = vertialcut;

	if(id == 'hordown'){
		var value = parseInt(document.getElementById('horinput').value);
		if(value-1 < 1){
			return;
		}
		horizontal= value-1;
		$("#horinput").val(horizontal);
	}else if(id == 'verdown'){
		var value = parseInt(document.getElementById('verinput').value);
		if(value-1 < 1){
			return;
		}
		vertical= value-1;
		$("#verinput").val(vertical);
	}else if(id == 'horcutdown'){
		var value = parseInt(document.getElementById('horcutinput').value);
		if(value-1 < 0){
			return;
		}
		horizontalcut= value-1;
		$("#horcutinput").val(horizontalcut);
	}else if(id == 'vercutdown'){
		var value = parseInt(document.getElementById('vercutinput').value);
		if(value-1 < 0){
			return;
		}
		vertialcut= value-1;
		$("#vercutinput").val(vertialcut);
	}
}

function wallsave(){
    var listObj1 = document.getElementById('vidiowallid');
    var vwi = listObj1.options[listObj1.selectedIndex].text;
    var wn = document.getElementById('wallname').value
    var listObj2 = document.getElementById('preset');
    var ps = listObj2.options[listObj2.selectedIndex].text;

    if(wn == "") {
        alert("Name can't be empty!");
        return; 
    }
	
    if((curselectvideowallid != curusedvideowallid) && ((vline != horizontal) || (vcolumn != vertical))) {
        alert("Use new Video Wall ID, please press Load button at first!");
        return; 
    }
	
    if((vline != horizontal) || (vcolumn != vertical)) {
        var cmd = "config set vs screen params ";
        cmd += horizontal;
        cmd += " ";
        cmd += vertical;
        cmd += " ";
        cmd += horizontalcut;
        cmd += " ";
        cmd += vertialcut;

        if (ws)
        {
            cmd += ";config get vs all params"; // ";config get vs screen params"; // +=: Update UI
            cmd += ";config set decoders display ip";
            ws.doSend(cmd);
            console.log(cmd);  
        }
    }
    else { // rows and volumns not changed 
        if((vHorCut != horizontalcut) || (vVerCut != vertialcut)) { // Cut is changed 
            var cmd = "config set vs rowcolumncutedge params ";
            cmd += horizontalcut;
            cmd += " ";
            cmd += vertialcut;

            if (ws)
            {
                cmd += ";config get vs all params"; // ";config get vs screen params"; // +=: Update UI
                ws.doSend(cmd);
                console.log(cmd);  
            }
        }
    }

    console.log( 'vidiowallid',vwi);
    console.log( 'wallname',wn);
    console.log( 'preset',ps);

    var wscmd = "scene save preset ";
    wscmd += wn;
    wscmd += " ";
    wscmd += vwi;
    wscmd += " ";
    wscmd += ps;

    if (ws)
    {
        ws.doSend(wscmd);
        console.log(wscmd);
    }

}

function wallload(){
    var listObj1 = document.getElementById('vidiowallid');
    var vwi = listObj1.options[listObj1.selectedIndex].text;
    
    var listObj2 = document.getElementById('preset');
    var ps = listObj2.options[listObj2.selectedIndex].text;

    console.log( 'vidiowallid',vwi);
    console.log( 'preset',ps);
	
    if(vwi!="choose")
    {
        var cmd = "scene recall preset ";
        cmd += vwi;
        cmd += " ";
        cmd += ps;
        cmd += ";config get vs all params;config get all sence ip list params;config get unicast all params;config get devlist";

        if (ws)
        {
            ws.doSend(cmd);
            console.log(cmd);
        }

        curusedvideowallid = vwi;
    }
}
