//supporting websocket
if (!window.WebSocket)
{
    alert("WebSocket not supported by this browser!");
}

document.onmousewheel = function() { if(event.ctrlKey) return false; }

function initWindowsUI()
{
    
}

function mouseOver()
{
	this.ClassName = "";
	this.ClassName = "a_over";
}

function mouseOut()
{
	this.ClassName = "";
	this.ClassName = "a_out";
}

var curRXDragip = "";
var curdisplayname = "";
var curdisplayip = "";
var curdisplayid = -1;
var cursourcetype = "esource";
var cursource  = -1;
var curchannel = -1;
var cursourceip  = "";

var usermode = 0; // video wall mode

var unicurindex = 0; //uniscreen current index

//remember the info of mouse-moved current window!
var curwinid   = -1;
var curwinx0   = -1;
var curwiny0   = -1;
var curwinx1   = -1;
var curwiny1   = -1;

//remember window resize or move
var iswindowchanged = false;

//remember the sync window data for mouse moving
var syncwinid   = -1;
var syncwinx0   = -1;
var syncwiny0   = -1;
var syncwinx1   = -1;
var syncwiny1   = -1;

//var zIndexMax  = 0; //window's zIndex Max

//Color
var selectcolor  = "rgb(255, 255, 255)";
var unselcolor   = "rgb(200, 200, 200)";
var disablecolor = "rgb(0, 0, 0)";

var scrcolor = "rgb(128, 128, 128)";

var clearRXSelect = 0;

function reset_clearrx()
{
    document.getElementById("vw_clear_apply_rx").classList.toggle("all_tx_hover", false); 
    clearRXSelect = 0;
}

function apply_vs_clearrx()
{
    if(clearRXSelect == 0) {
        //document.getElementById("vw_clear_apply_rx").classList.add("all_tx_hover");
        //document.getElementById("vw_clear_apply_rx").classList.remove("all_tx");
        //document.getElementById("vw_clear_apply_rx").classList.toggle("all_tx", false);		
        document.getElementById("vw_clear_apply_rx").classList.toggle("all_tx_hover", true); 
        clearRXSelect = 1;
    }
    else {
        //document.getElementById("vw_clear_apply_rx").classList.add("all_tx");
        //document.getElementById("vw_clear_apply_rx").classList.remove("all_tx_hover");
        document.getElementById("vw_clear_apply_rx").classList.toggle("all_tx_hover", false); 
        //document.getElementById("vw_clear_apply_rx").classList.toggle("all_tx", true);
        clearRXSelect = 0;
    }
}

function apply_vs_clearallrx()
{
    var wscmd = ""; // 
    if(usermode == 0) // video wall
    {
        var cmd = "config set clear vs screen tx params";

        if (ws) {
            cmd += ";config get vs all wins"; // ";config get vs screen params"; // +=: Update UI
            ws.doSend(cmd);
            console.log(cmd);
        }
    }
    else if(usermode == 1) // unicast 
    {
        var cmd = "config set clear unicast screen tx params";

        if (ws) {
            cmd += ";config get unicast all params";
            ws.doSend(cmd);
            console.log(cmd);
        }
    }
    else if(usermode == 2) // multicast 
    {
        var cmd = "config set clear multicast screen tx params";

        if (ws) {
            cmd += ";config get multicast win params";
            ws.doSend(cmd);
            console.log(cmd);
        }
    }
}

function apply_vs_reset()
{
    {
        var wscmd = ""; // 
        if(usermode == 0) // video wall
        {
            var cmd = "config set clear vs screen params";

            if (ws) {
                cmd += ";config get vs all params"; // ";config get vs screen params"; // +=: Update UI
                cmd += ";config get devlist";
                ws.doSend(cmd);
                console.log(cmd);
            }
        }
        else if(usermode == 1) // unicast 
        {
            var cmd = "config set clear unicast screen params";

            if (ws) {
                cmd += ";config get unicast screen params";
                cmd += ";config get devlist";
                ws.doSend(cmd);
                console.log(cmd);
            }
        }
        else if(usermode == 2) // multicast 
        {
            var cmd = "config set clear multicast screen params";

            if (ws) {
                cmd += ";config get multicast win params";
                ws.doSend(cmd);
                console.log(cmd);
            }
        }
    }
}

function dragRXOver(scrid, id)
{
    //console.log("dragRXover: " + id + " " + curdisplayid + " " + curRXDragip + " " + curdisplayname);
    //if (curRXDragip != "" && curdisplayid >= 0)
    {
        var wscmd = ""; // 
        if(usermode == 0) // video wall
        {
            addVWScrID(arrayVWScrId[id]);
            wscmd = "config set vs src params ";
        }
        else if(usermode == 1) // unicast 
        {
            wscmd = "config set unicast src params ";
        }
        else if(usermode == 2) // multicast 
        {
            wscmd = "config set multicast src params ";
        }

        if(usermode == 0) // video wall
        {
            wscmd += scrid;
            wscmd += " ";
        }
        else
        {
            wscmd += "0 ";
        }
        wscmd += id;
        wscmd += " ";

        if (usermode == 0) // video wall
        {
            //wscmd += ";config get vs all wins"; // 
            wscmd += ";config get vs all params;"; // ";config get vs screen params;";
        }
        else if (usermode == 1) // unicast
        {
            //drag RX to screen will make screen update!!!
            wscmd += ";config get unicast all params;"; //screen params;";
        }

        if (ws)
        {

            ws.doSend(wscmd);
            console.log(wscmd);
        }
    }

    curchannel = -1;
    cursource = -1;
    cursourceip  = "";
}

function dragRXIPOver(scrid, ip)
{
    //if (curRXDragip != "" && curdisplayid >= 0)
    {
        var wscmd = ""; // 
        if(usermode == 0) // video wall
        {
            addVWScrID(ip);
            wscmd = "config set vs src params ";
        }
        else if(usermode == 1) // unicast 
        {
            wscmd = "config set unicast src params ";
        }
        else if(usermode == 2) // multicast 
        {
            wscmd = "config set multicast src params ";
        }

        if(usermode == 0) // video wall
        {
            wscmd += scrid;
            wscmd += " ";
        }
        else
        {
            wscmd += "0 ";
        }
        wscmd += ip;
        wscmd += " ";

        if (usermode == 0) // video wall
        {
            //wscmd += ";config get vs all wins"; // 
            wscmd += ";config get vs all params;"; // ";config get vs screen params;";
            wscmd += ";config get unicast all params;";
            wscmd += ";config get devlist;";
        }
        else if (usermode == 1) // unicast
        {
            //drag RX to screen will make screen update!!!
            wscmd += ";config get unicast all params;"; //screen params;";
            wscmd += ";config get devlist;";
        }

        if (ws)
        {
            ws.doSend(wscmd);
            console.log(wscmd);
        }
        reset_clearrx(); 
}

    curchannel = -1;
    cursource = -1;
    cursourceip  = "";
}

//window double click feature
function doubleClick(id)
{
	// console.log("doubleClick: " + (id-1));
    var wscmd = "";

    if (usermode == 0) //video wall
    {
        wscmd += "config set vs dbl params ";
        wscmd += (id-1);
    }
    else if (usermode == 1) //unicast
    {
        wscmd += "config set unicast dbl params ";
        wscmd += ((id-1) + unicurindex * 5);
    }

    if (timerid)
    {
        clearTimeout(timerid);
        console.log("doubleclick clear timer");
    }

    if (ws)
    {
        ws.doSend(wscmd);
        console.log(wscmd);	
    }

    //after double click, dragresize obj need to be rebuild
    build_dragresize_obj();
}

function dragOver(id)
{
    //console.log("dragover: " + id + " " + cursource + " " + curchannel);

	if (curchannel >= 0 && cursource >= 0)
    {
        var wscmd = ""; // 
		if(usermode == 0) // video wall
		{
			wscmd = "config set vs url params ";
			wscmd += (id - 1);
		}
		else if(usermode == 1) // unicast 
		{
			wscmd = "config set unicast url params ";
			wscmd += ((id - 1) + unicurindex * 5);
		}
		else if(usermode == 2) // multicast 
		{
			wscmd = "config set multicast url params ";
			wscmd += (id - 1);
		}

        wscmd += " ";
        wscmd += cursourcetype;
        wscmd += " ";
        wscmd += cursourceip; // cursource;
        wscmd += " ";
        wscmd += curchannel;

        wscmd += ";";

        if (usermode == 0)
        {
            wscmd += "config get vs win params ";
            wscmd += (id - 1);
        }
        else if (usermode == 1)
        {
            wscmd += "config get unicast win params ";
            wscmd += ((id-1) + unicurindex * 5);
        }
        else
        {
            wscmd += "config get multicast win params";
        }

        if (ws)
        {
            ws.doSend(wscmd);
            console.log(wscmd);
        }
        reset_clearrx(); 
    }

    curchannel = -1;
    cursource = -1;
    cursourceip  = "";
}

//window count
function vw_showallwin(flag)
{
    for (var i = 1; i <= line * column * 5; i ++)
    {
        var win = document.getElementById("vwwin" + i);

        if (flag == 1)
        {
            win.style.visibility = "visible"; //visible       
        }
        else
        {
            win.style.visibility = "hidden"; //hide
        }
    }    
}

function vw_showwin(screenid, flag)
{
    for (var i = screenid * 5 + 1; i < screenid * 5 + 5 + 1; i ++)
    {
        var win = document.getElementById("vwwin" + i);

        if (flag == 1)
        {
            win.style.visibility = "visible"; //visible       
        }
        else
        {
            win.style.visibility = "hidden"; //hide
        }
    }
}

function vw_showscreen(flag, line, column)
{
    for (var i = 1; i <= line * column; i ++)
    {
        var scr = document.getElementById("vwscr" + i);

        if (flag == 1)
        {
            scr.style.visibility = "visible"; //visible       
        }
        else
        {
            scr.style.visibility = "hidden"; //hide
        }
    }    
}

function uni_showallwin(flag)
{
    for (var i = 1; i <= 5; i ++)
    {
        var win = document.getElementById("uniwin" + i);

        if (flag == 1)
        {
            win.style.visibility = "visible"; //visible       
        }
        else
        {
            win.style.visibility = "hidden"; //hide
        }
    }    
}

function uni_showscreen(flag)
{
    var scr = document.getElementById("uniscr");

    if (flag == 1)
    {
        scr.style.visibility = "visible"; //visible       
    }
    else
    {
        scr.style.visibility = "hidden"; //hide
    }
}

function mul_showscreen(flag)
{
    var scr = document.getElementById("mulscr");

    if (flag == 1)
    {
        scr.style.visibility = "visible"; //visible       
    }
    else
    {
        scr.style.visibility = "hidden"; //hide
    }
}

function createsubwin(tag, x, y, width, height, cnt, startid)
{
    if (cnt == 1)
    {
        var win1 = document.getElementById(tag + (startid + 1));
        var win2 = document.getElementById(tag + (startid + 2));
        var win3 = document.getElementById(tag + (startid + 3));
        var win4 = document.getElementById(tag + (startid + 4));
        var win5 = document.getElementById(tag + (startid + 5));

        if (win1)
        {
            win1.style.visibility = "visible";//show
            win1.style.left   = x + "px";
            win1.style.top    = y + "px";
            win1.style.width  = parseInt(width) + "px";
            win1.style.height = parseInt(height) + "px";
            win1.style.background = unselcolor; //unselcolor; //"rgb(221, 204, 204)";         
        }

        if (win2)
        {		
            win2.style.visibility = "hidden";//hide
        }

        if (win3)
        {
            win3.style.visibility = "hidden";//hide
        }

        if (win4)
        {
            win4.style.visibility = "hidden";//hide
        }

        if (win5)
        {
            win5.style.visibility = "hidden";//hide
        }
    }
    else if (cnt == 4)
    {
        var win1 = document.getElementById(tag + (startid + 1));
        var win2 = document.getElementById(tag + (startid + 2));
        var win3 = document.getElementById(tag + (startid + 3));
        var win4 = document.getElementById(tag + (startid + 4));
        var win5 = document.getElementById(tag + (startid + 5));

        if (win1)
        {
            win1.style.visibility = "visible";//show
            win1.style.left = x + "px";
            win1.style.top = y + "px";
            win1.style.width = parseInt(width / 2) - 1 + "px";
            win1.style.height = parseInt(height / 2) - 1 + "px";
            win1.style.background = unselcolor; //"rgb(221, 204, 204)";        
        }

        if (win2)
        {
            win2.style.visibility = "visible";
            win2.style.left = x + parseInt(width / 2) + "px";
            win2.style.top = y + "px";
            win2.style.width = parseInt(width / 2) - 1 + "px";
            win2.style.height = parseInt(height / 2) - 1 + "px";
            win2.style.background = unselcolor; //"rgb(221, 204, 204)";         
        }

        if (win3)
        {
            win3.style.visibility = "visible";
            win3.style.left = x + "px";
            win3.style.top = y + parseInt(height / 2) + "px"
            win3.style.width = parseInt(width / 2) - 1 + "px";
            win3.style.height = parseInt(height / 2) - 1 + "px";
            win3.style.background = unselcolor; //"rgb(221, 204, 204)";          
        }

        if (win4)
        {
            win4.style.visibility = "visible";
            win4.style.left = x + parseInt(width / 2) + "px";
            win4.style.top = y + parseInt(height / 2) + "px";
            win4.style.width = parseInt(width / 2) - 1 + "px";
            win4.style.height = parseInt(height / 2) - 1 + "px";
            win4.style.background = unselcolor; //"rgb(221, 204, 204)";        
        }

        if (win5)
        {
            win5.style.visibility = "hidden";
            win5.style.background = unselcolor; //"rgb(221, 204, 204)";         
        }
    }
    else if (cnt == 5)
    {
        var win1 = document.getElementById(tag + (startid + 1));
        var win2 = document.getElementById(tag + (startid + 2));
        var win3 = document.getElementById(tag + (startid+ 3));
        var win4 = document.getElementById(tag + (startid + 4));
        var win5 = document.getElementById(tag + (startid+ 5));

        if (win1)
        {
            win1.style.visibility = "visible";
            win1.style.left = x + "px";
            win1.style.top = y + "px";
            win1.style.width = parseInt(width) - 1 + "px";
            win1.style.height = parseInt(height * 3 / 4) - 1 + "px";
            win1.style.background = unselcolor; //"rgb(221, 204, 204)";        
        }

        if (win2)
        {
            win2.style.visibility = "visible";
            win2.style.left = x + "px";
            win2.style.top = y + parseInt(height * 3 / 4) + "px";
            win2.style.width = parseInt(width / 4) - 1 + "px";
            win2.style.height = parseInt(height / 4) - 1 + "px";
            win2.style.background = unselcolor; //"rgb(221, 204, 204)";  
        }

        if (win3)
        {
            win3.style.visibility = "visible";
            win3.style.left = x + parseInt(width / 4) + "px";
            win3.style.top = y + parseInt(height * 3 / 4) + "px";
            win3.style.width = parseInt(width / 4) - 1 + "px";
            win3.style.height = parseInt(height / 4) - 1 + "px";
            win3.style.background = unselcolor; //"rgb(221, 204, 204)";  
        }

        if (win4)
        {
            win4.style.visibility = "visible";
            win4.style.left = x + parseInt(width / 2) + "px";
            win4.style.top = y + parseInt(height * 3 / 4) + "px";
            win4.style.width = parseInt(width / 4) - 1 + "px";
            win4.style.height = parseInt(height / 4) - 1 + "px";
            win4.style.background = unselcolor; //"rgb(221, 204, 204)";  
        }

        if (win5)
        {
            win5.style.visibility = "visible";
            win5.style.left = x + parseInt(width * 3 / 4) + "px";
            win5.style.top = y + parseInt(height * 3 / 4) + "px";
            win5.style.width = parseInt(width / 4) - 1 + "px";
            win5.style.height = parseInt(height / 4) - 1 + "px";
            win5.style.background = unselcolor; //"rgb(221, 204, 204)";  
        }
    }
} 

//user mode
//unicast: one RX
//multicast: all RX (one virtual RX to all real RX)
//videowall: video wall
var usermode = 1; //videowall, unicast, multicast

//vscreen line and column
var vline   = 2;
var vcolumn = 2;
var vHorCut = 2;
var vVerCut = 2;
var vwidth  = 3840;
var vheight = 2160;
var uwidth  = 1920;
var uheight = 1080;

//control big window in web
var ScrLeft   = 0; //28;
var ScrTop    = 0; //70;
var ScrWidth  = 0; //width of control big window
var ScrHeight = 0; //width of control big window

function handleData_Windows(data)
{
    var vals    = data.split("\t");
    var msgType = vals[0];
   
    //console.log(data);
    var ack = JSON.parse(data);

    if (ack && ack.vsscreeninfo)
    {
        var iscreen = 0;
        //console.log(data);
        var splitm = 0;

        for (var vsscreen in ack.vsscreeninfo)
        {
            var screen = ack.vsscreeninfo[iscreen ++];

            vline = screen.vsrow;
            console.log("vsrow = " + vline);
            $("#vsrow").val(vline);

            vcolumn = screen.vscolumn;
            console.log("vscolumn = " + vcolumn);
            $("#vscol").val(vcolumn);

            vHorCut = screen.vshorcut;
            console.log("vHorCut = " + vHorCut);
            $("#vshorcut").val(vHorCut);

            vVerCut = screen.vsvercut;
            console.log("vVerCut = " + vVerCut);			
            $("#vsvercut").val(vVerCut);

            vwidth = screen.vswidth;
            console.log("vswidth = " + vwidth);

            vheight = screen.vsheight;
            console.log("vsheight = " + vheight);

            vw_showallwin(0); //hide all window

            drawLine();
            createvwscr();

            removeVWScrIDList();
            for (var i = 0; i < vline * vcolumn; i ++)
            {
                var splitm = screen['vssplitnum[' + i + ']'];
                var ip = screen['vsdeviplist[' + i + ']'];
                var name = screen['vsdevnamelist[' + i + ']'];
                //name = "scr" + i;

                addVWScrID(ip); // addScrID(ip);

                if (ip && splitm > 0)
                {
                    createvwwin(i, splitm, 0); //only create window, and not send window layout to server! 
                }

                var txtname = "vwscrtxt" + parseInt(parseInt(i) + 1);
                var txt = document.getElementById(txtname);

                if (txt && name)
                {
                    txt.innerHTML = name;
                    //alert(name);
                }                
            }
        }

        console.log("total " + iscreen + " screens!");
    }
    else if(ack && ack.vsallsenceinfo)
    {
        for (var info in ack.vsallsenceinfo)
        {		
            var ipInfo = ack.vsallsenceinfo[info];
            var iRXCnt = ipInfo.vsdevipnum;
            removeOtherSceneScrIDList();
            for (var i = 0; i < iRXCnt; i ++)
            {
                var ipList = ipInfo['vsdeviplist[' + i + ']']; // screen['vsdeviplist[' + i + ']'];
                addOtherSceneScrID(ipList);
            }
        }
    }
    else if (ack && ack.unicastinfo)
    {
        var iunicast = 0; 
        var unicast = ack.unicastinfo[iunicast ++];

        uni_showallwin(0);
        createuniscr();

        removeUniScrIDList();

        uwidth = unicast.uniwidth;
        console.log("uwidth = " + uwidth);

        uheight = unicast.uniheight;
        console.log("uheight = " + uheight);

        for (var i = 0; i < 16; i ++)
        {
            unicurindex = unicast['curindex'];
            var splitm = unicast['unisplitnum[' + i + ']'];
            var ip = unicast['uniiplist[' + i + ']'];
            var name = unicast['uninamelist[' + i + ']'];

            addUniScrID(ip); // addScrID(ip);

            if ((i == unicurindex) && ip && splitm > 0)
            {
                createuniwin(splitm, 0); //only create window, and not send window layout to server! 

                var txt = document.getElementById("uniscrtxt");

                if (txt && name)
                {
                    txt.innerHTML = name;
                } 
            }
        }
    }
    else if(ack && ack.vswininfo)
    {
    	var iwin = 0;

        //console.log("get vswinInfo!");

        //rebuild window when get vswininfo!
        build_dragresize_obj();

    	for (var win in ack.vswininfo)
    	{
            var vwindow = ack.vswininfo[iwin ++];

            var vals = vwindow.vwval.split(",");
			
            //set pos
            var win = document.getElementById("vwwin" + (parseInt(vals[0]) + 1));
            var left;
            var top;
            var right;
            var bottom;
            var winid;
            var en;
            var valid;

           // console.log("ack winid(" + vals[0] + ") " + "pos("+parseInt(vals[4]) + "," + parseInt(vals[5]) + "," + parseInt(vals[6]) + "," + parseInt(vals[7]) + ")");
            valid  = vals[1];
            en     = vals[3];
            left   = parseInt(parseInt(vals[4]) * ScrWidth / vwidth + 0.5);
            top    = parseInt(parseInt(vals[6]) * ScrHeight / vheight + 0.5);
            right  = parseInt(parseInt(vals[5]) * ScrWidth / vwidth + 0.5);
            bottom = parseInt(parseInt(vals[7]) * ScrHeight / vheight + 0.5);

            //left = 0;
            //top = 0;
            //right = 0;
            //bottom = 0;

            //change control window, and need to set drag obj pos too!
            left   += ScrLeft;
            top    += ScrTop;
            right  += ScrLeft;
            bottom += ScrTop; 

            win.style.left   = left + "px";
            win.style.top    = top + "px";
            win.style.width  = parseInt(right - left + 1) + "px";
            win.style.height = parseInt(bottom - top + 1) + "px";

            winid = parseInt(vals[0]);
            if (parseInt(en) == 0)
            {
                //hide
                win.style.background = disablecolor; //"rgb(64, 64, 64)";
            }
            else
            {
                //show
                if (curwinid == winid)
                {
                    win.style.background = selectcolor; //"rgb(221, 204, 204)";                      
                }
                else
                {
                    win.style.background = unselcolor; //"rgb(221, 204, 204)";  
                }
            }
            win.style.visibility = "visible";			
            //show disable status
    	    //var win = document.getElementById("win" + (winid + 1));
    	    var iZindex = parseInt(vals[8]);
            win.style.zIndex = iZindex;

            if (winid == curwinid)
            {
                //0 base, pos in control window
                syncwinid   = winid;
                syncwinx0   = parseInt(left);
                syncwiny0   = parseInt(top);
                syncwinx1   = parseInt(right);
                syncwiny1   = parseInt(bottom);

                //build_dragresize_obj();
            }

            //vals[9] is urlname
            var txtname = "vwtxt" + (parseInt(vals[0]) + 1);
            var txt = document.getElementById(txtname);

            txt.innerHTML = "";
            if (vals[9] && (valid == 1))
            {
                if((parseInt(right - left + 1) > 300) && (parseInt(bottom - top + 1) > 240)){
                    txt.style.fontSize = "48px";
                    win.style.lineHeight = "60px";
                    txt.innerHTML = vals[9];
                }
                else if((parseInt(right - left + 1) > 150) && (parseInt(bottom - top + 1) > 120)){
                    txt.style.fontSize = "24px";
                    win.style.lineHeight = "32px";
                    txt.innerHTML = vals[9];
                }
                else {
                    txt.style.fontSize = "10px";
                    win.style.lineHeight = "16px";
                    txt.innerHTML = vals[9];
                }
                // txt.innerHTML = vals[9];
            }

            console.log("ack winid(" + winid + ") " + "en(" + en + ")" + " pos(" + parseInt(left) + "," + parseInt(right) + "," + parseInt(top) + "," + parseInt(bottom) + ")");
    	}        
    }
    else if(ack && ack.uniwininfo)
    {
        var iwin = 0;

        //console.log("get uniwinInfo!");

        //rebuild window when get uniwininfo!
        build_dragresize_obj();

        for (var win in ack.uniwininfo)
        {
            var uniwindow = ack.uniwininfo[iwin ++];

            var vals = uniwindow.unival.split(",");
            var id = parseInt(vals[0]) % 5;
            
            //set pos
            var win = document.getElementById("uniwin" + (id + 1));
            var left;
            var top;
            var right;
            var bottom;
            var winid;
            var en;
            var valid;

           // console.log("ack winid(" + vals[0] + ") " + "pos("+parseInt(vals[4]) + "," + parseInt(vals[5]) + "," + parseInt(vals[6]) + "," + parseInt(vals[7]) + ")");
            valid  = vals[1];
            en     = vals[3];
            left   = parseInt(parseInt(vals[4]) * ScrWidth / uwidth + 0.5);
            top    = parseInt(parseInt(vals[6]) * ScrHeight / uheight + 0.5);
            right  = parseInt(parseInt(vals[5]) * ScrWidth / uwidth + 0.5);
            bottom = parseInt(parseInt(vals[7]) * ScrHeight / uheight + 0.5);

            //left = 0;
            //top = 0;
            //right = 0;
            //bottom = 0;

            //change control window, and need to set drag obj pos too!
            left   += ScrLeft;
            top    += ScrTop;
            right  += ScrLeft;
            bottom += ScrTop; 

            win.style.left   = left + "px";
            win.style.top    = top + "px";
            win.style.width  = parseInt(right - left + 1) + "px";
            win.style.height = parseInt(bottom - top + 1) + "px";

            winid = parseInt(vals[0]);

            if (parseInt(en) == 0)
            {
                //hide
                win.style.background = disablecolor; //"rgb(64, 64, 64)";
            }
            else
            {
                //show
                if (curwinid == winid)
                {
                    win.style.background = selectcolor; //"rgb(221, 204, 204)";                      
                }
                else
                {
                    win.style.background = unselcolor; //"rgb(221, 204, 204)";  
                }
            }
	    win.style.visibility = "visible";			
            //show disable status
            //var win = document.getElementById("win" + (winid + 1));
            var iZindex = parseInt(vals[8]);
            win.style.zIndex = iZindex;

            if (winid == curwinid)
            {
                //0 base, pos in control window
                syncwinid   = winid;
                syncwinx0   = parseInt(left);
                syncwiny0   = parseInt(top);
                syncwinx1   = parseInt(right);
                syncwiny1   = parseInt(bottom);

                //build_dragresize_obj();
            }

            //vals[9] is urlname
            var txtname = "unitxt" + parseInt(parseInt(id) + 1);
            var txt = document.getElementById(txtname);

	    txt.innerHTML = "";
            if (vals[9] && (valid == 1))
            {
                if((parseInt(right - left + 1) > 300) && (parseInt(bottom - top + 1) > 240)){
                    txt.style.fontSize = "48px";
                    win.style.lineHeight = "60px";
                    txt.innerHTML = vals[9];
                }
                else if((parseInt(right - left + 1) > 150) && (parseInt(bottom - top + 1) > 120)){
                    txt.style.fontSize = "24px";
                    win.style.lineHeight = "32px";
                    txt.innerHTML = vals[9];
                }
                else {
                    txt.style.fontSize = "10px";
                    win.style.lineHeight = "16px";
                    txt.innerHTML = vals[9];
                }
                // txt.innerHTML = vals[9];
            }

            console.log("ack uniwinid(" + winid + ") " + "en(" + en + ")" + " pos(" + parseInt(left) + "," + parseInt(right) + "," + parseInt(top) + "," + parseInt(bottom) + ")");
        }        
    }
    else if(ack && ack.mulwininfo)
    {
        var iwin = 0;

        for (var win in ack.mulwininfo)
        {
            var mulwindow = ack.mulwininfo[iwin];

            var vals = mulwindow.mulval.split(",");

            //vals[9] is urlname
            var txtname = "multxt" + parseInt(parseInt(iwin) + 1);
            var txt = document.getElementById(txtname);

            txt.innerHTML = "";
            if (vals[9])
            {
                txt.innerHTML = vals[9];
            }

            iwin ++;
        }        
    }    
    else if (ack && ack.usermode)
    {
        usermode = ack.usermode.mode;

        tabNavSm(usermode + 1);
        loadWindow();
        getAllData();
        //update RX list;
       
        console.log("usermode: " + usermode);
    }
}

//create window
var line = 4;
var column = 4;

function createuniscr()
{
    var unicanvas = document.getElementById('unicanvas');

    unicanvas.width = ScrWidth;
    unicanvas.height = ScrHeight;

    var win = document.getElementById("uniscr");

    if (win)
    {
        win.style.visibility = "visible";//show
        win.style.left   = ScrLeft + "px";
        win.style.top    = ScrTop + "px";
        win.style.width  = ScrWidth + "px";
        win.style.height = ScrHeight + "px";
        win.style.background = scrcolor; //unselcolor; //"rgb(221, 204, 204)";         
        win.style.zIndex = 0;
    }

    var txt = document.getElementById("uniscrtxt");

    if (txt)
    {
        txt.innerHTML = "";
    }
}

function createuniwin(cnt, flag)
{
    if (cnt == 1) {
       /* 1 x 1 */      
       var left, top;
       left = ScrLeft;
       top = ScrTop
       createsubwin("uniwin", left, top, ScrWidth, ScrHeight, 1, 0);
    }
    else if (cnt == 4) {
        /* 2 x 2 */
        var left, top;
        left = ScrLeft;
        top = ScrTop
       createsubwin("uniwin", left, top, ScrWidth, ScrHeight, 4, 0);
    }
    else if (cnt == 5) {
        /* 2 x 2 */
        var left, top;
        left = ScrLeft;
        top = ScrTop
       createsubwin("uniwin", left, top, ScrWidth, ScrHeight, 5, 0);
    }
    
    if (ws != null && flag)
    {
    	var wscmd = "config set unicast split params ";
        wscmd += "0 ";
        wscmd += cnt;
        wscmd += " ";
        wscmd += 0;	

        wscmd += ";config get unicast all params;"; //get all window info back!

        ws.doSend(wscmd);
        console.log(wscmd);		
    }

    //zIndexMax = 0; //zIndexMax to make drag window on top
    //
    build_dragresize_obj();

    syncwinid = -1; //no sync window!
    curwinid  = -1; //no current window!
}

function createmulscr()
{
    var mulcanvas = document.getElementById('mulcanvas');

    mulcanvas.width = ScrWidth;
    mulcanvas.height = ScrHeight;

    var win = document.getElementById("mulscr");

    if (win)
    {
        win.style.visibility = "visible";//show
        win.style.left   = ScrLeft + "px";
        win.style.top    = ScrTop + "px";
        win.style.width  = ScrWidth + "px";
        win.style.height = ScrHeight + "px";
        win.style.background = scrcolor; //unselcolor; //"rgb(221, 204, 204)";         
        win.style.zIndex = 0;
    }
}

function createmulwin()
{
    var left, top;
    left = ScrLeft;
    top = ScrTop;
    createsubwin("mulwin", left, top, ScrWidth, ScrHeight, 1, 0);    
}

function createvwscr()
{
    var vwcanvas = document.getElementById('vwcanvas');

    vwcanvas.width = ScrWidth;
    vwcanvas.height = ScrHeight;

    console.log("screen size: " + ScrWidth + ", " + ScrHeight);
    //console.log("vline="+vline+" " + "vcolumn="+vcolumn);
    for (var i = 0; i < line * column; i ++)
    {
        var win = document.getElementById("vwscr" + parseInt(i + 1));

        if (win)
        {
            win.style.visibility = "hidden";//hidden
        }    	
    }

    for (var i = 0; i < vline * vcolumn; i ++)
    {
        var win = document.getElementById("vwscr" + parseInt(i + 1));

        if (win)
        {
            win.style.visibility = "visible";//show
            win.style.left   = ScrLeft + (ScrWidth / vcolumn) * (i % vcolumn) + "px";
            win.style.top    = ScrTop + (ScrHeight / vline) * parseInt(i / vcolumn) + "px";
            win.style.width  = (ScrWidth / vcolumn) + "px";
            win.style.height = (ScrHeight / vline) + "px";
            win.style.background = scrcolor; //unselcolor; //"rgb(221, 204, 204)";         
            win.style.zIndex = 0;
            //alert(win.style.left + " " + win.style.top);
        }

        var txt = document.getElementById("vwscrtxt" + parseInt(parseInt(i) + 1)); //only one label valid????

        if (txt)
        {
            txt.style.marginTop = "10px"; //parseInt(parseInt(win.style.height) / 2) + "px";
            txt.style.marginLeft = "10px";
            txt.innerHTML = "";
        }

    }
}

function createvwscrinit()
{
    var vwcanvas = document.getElementById('vwcanvas');

    vwcanvas.width = ScrWidth;
    vwcanvas.height = ScrHeight;

    console.log("screen size: " + ScrWidth + ", " + ScrHeight);

	for (var i = 0; i < 1; i ++)
    {
        var win = document.getElementById("vwscr" + parseInt(i + 1));

        if (win)
        {
            win.style.visibility = "visible";//show
            win.style.left   = (ScrLeft) + "px";
            win.style.top    = (ScrTop) + "px";
            win.style.width  = (ScrWidth) + "px";
            win.style.height = (ScrHeight) + "px";
            win.style.background = unselcolor; // scrcolor; //unselcolor; //"rgb(221, 204, 204)";         
            win.style.zIndex = 0;
            //alert(win.style.left + " " + win.style.top);
        }
    }
}

function createvwwin(index, cnt, flag)
{
    //cnt: win number
    //flag: send socket data or not.
    if (cnt == 0) {
        vw_showallwin(0);
    }
    else if (cnt == 1) {
       /* 1 x 1 */   	
        var left, top;
        left = ScrLeft+(parseInt(index) % parseInt(vcolumn))*(ScrWidth / vcolumn);
        top = ScrTop+parseInt(index / vcolumn)*(ScrHeight / vline)
        createsubwin("vwwin", left, top, ScrWidth / vcolumn, ScrHeight / vline, 1, index*5);
    }
	else if (cnt == 4) {
        /* 2 x 2 */
        var left, top;
        left = ScrLeft+(parseInt(index) % parseInt(vcolumn))*(ScrWidth / vcolumn);
        top = ScrTop+parseInt(index / vcolumn)*(ScrHeight / vline)
        createsubwin("vwwin", left, top, ScrWidth / vcolumn, ScrHeight / vline, 4, index*5);
	}
	else if (cnt == 5) {
        /* 2 x 2 */
        var left, top;
        left = ScrLeft+(parseInt(index) % parseInt(vcolumn))*(ScrWidth / vcolumn);
        top = ScrTop+parseInt(index / vcolumn)*(ScrHeight / vline)
        createsubwin("vwwin", left, top, ScrWidth / vcolumn, ScrHeight / vline, 5, index*5);
	}
	
	if (ws != null && flag)
	{
            var wscmd = "config set vs split params ";
            wscmd += index;
            wscmd += " ";
            wscmd += cnt;
            wscmd += " ";
            wscmd += 0;	
        
           if(usermode == 0) // video wall
           {
    	       wscmd += ";config get vs all wins";
           }
	   ws.doSend(wscmd);
           console.log(wscmd);		
	}

    //zIndexMax = 0; //zIndexMax to make drag window on top
    //
    build_dragresize_obj();

    syncwinid = -1; //no sync window!
    curwinid  = -1; //no current window!
}

function getAllData()
{
    var wscmd;

    wscmd = "config get vs all params;";
    wscmd += "config get all sence ip list params;";
    wscmd += "config get unicast all params;";
    wscmd += "config get multicast win params;";
    wscmd += "config get devlist;";
    wscmd += "config get ipsources;";
    wscmd += "config get winmodes;";

    if (ws)
    {
        ws.doSend(wscmd);
        //console.log(wscmd);  
    }
}

function createWinObj()
{
    //80 windows
    var vwwin = document.getElementById('vwwin');
    var html = "";

    vwwin.innerHTML = "";

    for (var i = 1; i <= line * column; i ++)
    {
        html += "<div id='vwscrarea" + i + "' name='vwscrarea' style='float:left;width:100%;height: 100%;'>";
        html += "    <div id='vwscr" + i + "' name='vwscr' class='drsElement drsMoveHandle' ";
        html += "style='background: rgb(200, 200, 220); position: absolute; ";
        html += "left: 19px; top: 104px; width: 862px; height: 623.25px; ";
        html += "text-align: center;line-height:40px; visibility: hidden'> ";
        html += "        <label id='vwscrtxt" + i + "' name='vwscrtxt" + i + "' width='50px' height='20px' style='font-size:30px; color:blue' />";
        html += "    </div>";
        html += "</div>";
    }

    //at most support 4 * 4 * 5 window-objs
    for (var i = 1; i <= line * column * 5; i ++)
    {
        html += "<div id='vwarea" + i + "' name='vwarea" + i + "' style='float:left;width:100%;height: 100%;'>";
        html += "    <div id='vwwin" + i + "' name='vwwin" + i + "' class='drsElement drsMoveHandle' ";
        html += "onmouseover='dragOver(" + i + ");' ondblclick='doubleClick(" + i + ");' ";
        html += "style='background: rgb(200, 200, 220); position: absolute; ";
        html += "left: 19px; top: 104px; width: 862px; height: 623.25px; ";
        html += "text-align: center;line-height:40px; visibility: hidden'> ";
        html += "        <label id='vwtxt" + i + "' name='vwtxt" + i + "' width='50px' height='20px' style='color:green' />";
        html += "    </div>";
        html += "</div>";
    }

    vwwin.innerHTML = html;

    var uniwin = document.getElementById('uniwin');

    html = "";
    uniwin.innerHTML = "";

    html += "<div id='uniscrarea' name='uniscrarea' style='float:left;width:100%;height: 100%;'>";
    html += "    <div id='uniscr' name='uniscr' class='drsElement drsMoveHandle' ";
//    html += "onmousemove='scrMouseMove();' onclick='scrMouseClick();'";
    html += "style='background: rgb(200, 200, 220); position: absolute; ";
    html += "left: 19px; top: 104px; width: 862px; height: 623.25px; ";
    html += "text-align: center;line-height:40px; visibility: hidden'> ";
    html += "        <label id='uniscrtxt' name='uniscrtxt' width='50px' height='20px' style='font-size:40px; color:blue' />";
    html += "    </div>";
    html += "</div>";

    for (var i = 1; i <= 5; i ++)
    {
        html += "<div id='uniarea" + i + "' name='uniarea" + i + "' style='float:left;width:100%;height: 100%;'>";
        html += "    <div id='uniwin" + i + "' name='uniwin" + i + "' class='drsElement drsMoveHandle' ";
        html += "onmouseover='dragOver(" + i + ");' ondblclick='doubleClick(" + i + ");' ";
        html += "style='background: rgb(200, 200, 220); position: absolute; ";
        html += "left: 19px; top: 104px; width: 862px; height: 623.25px; ";
        html += "text-align: center;line-height:40px; visibility: hidden'> ";
        html += "        <label id='unitxt" + i + "' name='unitxt" + i + "' width='50px' height='20px' style='color:green' />";
        html += "    </div>";
        html += "</div>";
    } 
    uniwin.innerHTML = html;

    var mulwin = document.getElementById('mulwin');

    html = "";
    mulwin.innerHTML = "";

    html += "<div id='mulscrarea' name='mulscrarea' style='float:left;width:100%;height: 100%;'>";
    html += "    <div id='mulscr' name='mulscr' class='drsElement drsMoveHandle' ";
 //   html += "onmousemove='scrMouseMove();' onclick='scrMouseClick();'";
    html += "style='background: rgb(200, 200, 220); position: absolute; ";
    html += "left: 19px; top: 104px; width: 862px; height: 623.25px; ";
    html += "text-align: center;line-height:40px; visibility: hidden'> ";
    html += "        <label id='mulscrtxt' name='mulscrtxt' width='50px' height='20px' />";
    html += "    </div>";
    html += "</div>";

    for (var i = 1; i <= 1; i ++)
    {
        html += "<div id='mularea" + i + "' name='mularea" + i + "' style='float:left;width:100%;height: 100%;'>";
        html += "    <div id='mulwin" + i + "' name='mulwin" + i + "' class='drsElement drsMoveHandle' ";
        html += "onmouseover='dragOver(" + i + ");' ondblclick='doubleClick(" + i + ");' ";
        html += "style='background: rgb(200, 200, 220); position: absolute; ";
        html += "left: 19px; top: 104px; width: 862px; height: 623.25px; ";
        html += "text-align: center;line-height:80px; visibility: hidden'> ";
        html += "        <label id='multxt" + i + "' name='multxt" + i + "' width='50px' height='20px' style='font-size:60px; color:green' />";
        html += "    </div>";
        html += "</div>";
    } 

    mulwin.innerHTML = html;
}

function user_mode(mode)
{
    //send message to channel.html
    var modeOrg = usermode;
    var cmd  = "config set vs usermode " + mode;
        cmd += ";config get devlist";
        cmd += ";config get ipsources";
    if (mode == 0) // video wall
    {
        cmd += ";config get vs all wins;";
    }
    else if (mode == 1) // unicast
    {
        cmd += ";config get unicast all params;";
    }
    else
    {
        cmd += ";config get multicast win params;";
    }

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
    }

    if(modeOrg != mode) {
        syncwinid = -1; //no sync window!
        curwinid  = -1; //no current window!
    }

	usermode = mode;

    if (usermode == 0)
    {
        vw_showscreen(1, vline, vcolumn);
        uni_showscreen(0);
        mul_showscreen(0);
    }
    else if (usermode == 1)
    {
        vw_showscreen(0, vline, vcolumn);
        uni_showscreen(1);
        mul_showscreen(0);
    }
    else if (usermode == 2)
    {
        vw_showscreen(0, vline, vcolumn);
        uni_showscreen(0);
        mul_showscreen(1);
    }
}

//load loadWindow when page resize
window.onresize = function() {    
    // document.location.href = "main.html";
    //alert(window.outerHeight + "x" + window.outerWidth);
    loadWindow();
    
    var mainctrlcheck = document.getElementById('mainctrl');

    if((mainctrlcheck.clientWidth == 0) || (mainctrlcheck.clientHeight == 0)) {
        console.log("width or height is 0"); 
        return;
    }

    var wscmd = ""; // 
    if (usermode == 0)
    {
        wscmd = "config get vs all params;";
    }
    else if (usermode == 1)
    {
        wscmd = "config get unicast all params;";
    }
    else if (usermode == 2)
    {
        wscmd = "config get multicast win params;";
    }

    if (ws)
    {
        ws.doSend(wscmd);
        console.log(wscmd);  
    }
}

//mainctrl size
var mainctrl_width = 0;
var mainctrl_height = 0;

/* call loadWindow when page loaded */
function loadWindow()
{
    var mainctrl = document.getElementById('mainctrl');

    if((mainctrl.clientWidth == 0) || (mainctrl.clientHeight == 0)) {
        console.log("width or height is 0"); 
        return;
    }
    mainctrl_width = mainctrl.clientWidth;
    mainctrl_height = mainctrl.clientHeight;

    console.log("whole vscreen UI width is " + mainctrl_width + ", height is " + mainctrl_height);

    if (usermode == 0)
    {
        //videowall
        var vwcanvas = document.getElementById('vwcanvas');

        ScrTop = vwcanvas.offsetTop;
        ScrLeft = vwcanvas.offsetLeft;
    }
    else if (usermode == 1)
    {
        //unicast
        var unicanvas = document.getElementById('unicanvas');

        ScrTop = unicanvas.offsetTop;
        ScrLeft = unicanvas.offsetLeft;
    }
    else
    {
        //mulcast
        var mulcanvas = document.getElementById('mulcanvas');

        ScrTop = mulcanvas.offsetTop;
        ScrLeft = mulcanvas.offsetLeft;
    }
    ScrWidth = mainctrl_width - (ScrLeft - mainctrl.offsetLeft) * 2; //x padding left & right
    ScrHeight = mainctrl_height - (ScrTop - mainctrl.offsetTop) - (ScrLeft - mainctrl.offsetLeft); //use x padding for y padding

    createWinObj();

    createvwscrinit(); // createvwscr();
    for (var i = 0; i < vline * vcolumn; i ++)
    {
        createvwwin(i, 0, 0); //only create window, and not send window layout to server! 
    }
    
    createuniscr();
    createuniwin(5, 0);

    createmulscr();
    createmulwin(1, 0);

    if (!ws)
    {
        //build socket
        setupSocket();
    }

    var messageHandle = function(e) {
        //alert(e.data);
    };

    if (window.addEventListener) {
        window.addEventListener("message", messageHandle, false);
        //alert("addEvent");
    } else if (window.attachEvent) {

        window.attachEvent('onmessage', messageHandle);
        //alert("attachEvent");
    }
}

function resizeWindow()
{
    if (!isMobileBrowser())
    {
        //only for pc
        width = document.body.clientWidth;
        height = document.body.clientHeight;

        saveAllBtn = document.getElementById('WinParent');

        console.log(width + "," + height + " "+line+" "+column);
    }
}

//screen mouse event
function scrMouseMove()
{

}

function scrMouseClick()
{
    
}

var mousePressed =false;
var lastX,lastY;
var ctx;

function initMouseEvent() {

    var ctx = document.getElementById('vwcanvas');

    var oGC = ctx.getContext('2d');

    ctx.onmousedown = function(ev) {
        var ev = ev || window.event;
        oGC.moveTo(ev.clientX - ctx.offsetLeft, ev.clientY - ctx.offsetTop);
    };
    document.onmousemove = function(ev){
        var ev = ev || window.event;
        oGC.lineTo(ev.clientX-ctx.offsetLeft,ev.clientY-ctx.offsetTop);
        oGC.stroke();
    };
    document.onmouseup = function(){
        //document.onmousemove = null;
        //document.onmouseup = null;
        clearArea();
    };
}

function clearArea(){
    console.log(".......................clear area.");
    oGC.setTransform(1,0,0,1,0,0);
    oGC.clearRect(0,0,ctx.canvas.width,ctx.canvas.height);
}

function build_dragresize_obj()
{
    //manager all elm
    var dragresize = new DragResize('dragresize',
    {
        minWidth: 30,
        minHeight: 25,
        minLeft: ScrLeft,
        minTop: ScrTop,
        maxLeft: ScrLeft + ScrWidth,
        maxTop: ScrTop + ScrHeight
    });

    dragresize.isElement = function (elm) {
        //elm might be window obj
        if (elm.className && elm.className.indexOf('drsElement') > -1)
            return true;
    };
    dragresize.isHandle = function (elm) {
        //elm might be window obj
        if (elm.className && elm.className.indexOf('drsMoveHandle') > -1)
            return true;
    };
    dragresize.getId = function (elm) {
        return elm.id; //get window id
    }

    dragresize.ondragfocus = function () { };
    dragresize.ondragstart = function (isResize) { };
    dragresize.ondragmove = function (isResize) { };
    dragresize.ondragend = function (isResize) { };
    dragresize.ondragblur = function () { };
    
    dragresize.apply(document);    
}

var arrayVWScrId = new Array(); 
var arrayUniScrId = new Array();
var arrayOtherSceneScrId = new Array();

function removeVWScrIDList()
{
    arrayVWScrId = null;
    arrayVWScrId = new Array();
}

function removeUniScrIDList()
{
    arrayUniScrId = null;
    arrayUniScrId = new Array();
}

function removeOtherSceneScrIDList()
{
    arrayOtherSceneScrId = null;
    arrayOtherSceneScrId = new Array();
}

function addVWScrID(ip)
{
    arrayVWScrId.push(ip);
}

function addUniScrID(ip)
{
    arrayUniScrId.push(ip);
}

function addOtherSceneScrID(ip)
{
    arrayOtherSceneScrId.push(ip);
}

//function addScrID(ip)
//{
    //console.log("addScrID " + ip);
//    if (usermode == 0) //videowall
//    {
//        arrayVWScrId.push(ip);
//    }
//    else if (usermode == 1)
//    {
//        arrayUniScrId.push(ip);
//    }
//    else
//    {
//        arrayMulScrId.push(ip);
//    }
//}

function setScrID(id, ip)
{
    console.log("setScrID " + id + " " + ip);

    if (usermode == 0) //videowall
    {
        if (id >= arrayVWScrId.length)
        {
            alert("id >= arrayScrId.length");

            return;   
        }

        for (var i = 0; i < arrayVWScrId.length; i ++)
        {
            if (i != id)
            {
                if (arrayVWScrId[i] == ip)
                {
                    arrayVWScrId[i] = "";
                    //var txt = document.getElementById("vwscrtxt" + i); //only one label valid????
                    //if (txt)
                    //{
                    //    txt.innerHTML = "";
                    //}

                    vw_showwin(id, 0); //hidden the window in screen
                }
            }
            else
            {
                arrayVWScrId[id] = ip;
            }
        }
    }
    else if (usermode == 1)
    {
        var iFind = -1; 
        for (var i = 0; i < arrayUniScrId.length; i ++)
        {
            if (arrayUniScrId[i] == ip)
            {
                iFind = i;
            }
        }
        if(iFind == -1) {
            if(arrayUniScrId.length >= 15) {
                arrayUniScrId[0] = ip;
            }
            else {
                arrayUniScrId.push(ip);
            }
        }
    }
    else
    {
        arrayMulScrId[0] = ip;
    }
}

function getVWScrIDbyIP(ip)
{
    for (var i = 0; i < arrayVWScrId.length; i ++)
    {
    	// console.log("arrayVWScrId: " + i + ": " + arrayVWScrId[i] + "  ip: "  + ip);
        if (arrayVWScrId[i] == ip)
        {
            return i;
        }
     }

    return -1;
}

function getUniScrIDbyIP(ip)
{
    for (var i = 0; i < arrayVWScrId.length; i ++)
    {
        if (arrayVWScrId[i] == ip)
        {
            return -1;
        }
    }

    for (var i = 0; i < arrayUniScrId.length; i ++)
    {
        if (arrayUniScrId[i] == ip)
        {
            return i;
        }
    }

    return -1;
}

function getOtherSceneScrIDbyIP(ip)
{
    for (var i = 0; i < arrayOtherSceneScrId.length; i ++)
    {
        if (arrayOtherSceneScrId[i] == ip)
        {
            return i;
        }
    }

    return -1;
}

function checkScrAvailablebyIP(ip)
{
    if (usermode == 0)
    {
        if (getVWScrIDbyIP(ip) > -1)
        {
            return true;
        }
    }
    else if (usermode == 1)
    {
        var scrid = getUniScrIDbyIP(ip);

        if ((scrid > -1) && (unicurindex == scrid))
        {
            return true;
        }
    }
    
    return false;
}

function drawLine() {
    //console.log(ScrWidth+"------" + ScrHeight);
    var vwcanvas = document.getElementById("vwcanvas");

    vwcanvas.width = ScrWidth;
    vwcanvas.height = ScrHeight;

    var unicanvas = document.getElementById("unicanvas");

    unicanvas.width = ScrWidth;
    unicanvas.height = ScrHeight;

    var mulcanvas = document.getElementById("mulcanvas");

    mulcanvas.width = ScrWidth;
    mulcanvas.height = ScrHeight;

    var content = vwcanvas.getContext("2d");//graphics context
    content.fillStyle = '#00ff00'; //green

    //horizontal line
    for (var i = 0; i < vline; i ++)
    {
        if (i != 0 && i != vline)
        {
            content.fillRect(0, i * (ScrHeight / vline) - 1, ScrWidth, 3);
        }
    }

    //vertical line
    for (var j = 0; j < vcolumn; j ++)
    {
        if (j != 0 && j != vcolumn)
        {
            content.fillRect(0 + j * (ScrWidth / vcolumn) - 1, 0, 3, ScrHeight);
        }
    }

    build_dragresize_obj();
}

if (typeof addEvent != 'function') {
    var addEvent = function (o, t, f, l) {
        var d = 'addEventListener',
        n = 'on' + t,
        rO = o,
        rT = t,
        rF = f,
        rL = l;
        if (o[d] && !l) return o[d](t, f, false);
        if (!o._evts) o._evts = {};
        if (!o._evts[t]) {
            o._evts[t] = o[n] ? {
                b: o[n]
            } : {};
            o[n] = new Function('e', 'var r=true,o=this,a=o._evts["' + t + '"],i;for(i in a){o._f=a[i];r=o._f(e||window.event)!=false&&r;o._f=null}return r');
            if (t != 'unload')
                addEvent(window, 'unload',
            function () {
                removeEvent(rO, rT, rF, rL)
            })
        }
        if (!f._i) f._i = addEvent._i++;
        o._evts[t][f._i] = f
    };
    addEvent._i = 1;
    var removeEvent = function (o, t, f, l) {
        var d = 'removeEventListener';
        if (o[d] && !l) return o[d](t, f, false);
        if (o._evts && o._evts[t] && f._i) delete o._evts[t][f._i]
    }
}

function cancelEvent(e, c) {
    e.returnValue = false;
    if (e.preventDefault) e.preventDefault();
    if (c) {
        e.cancelBubble = true;
        if (e.stopPropagation) e.stopPropagation()
    }
};

/* -- resize window ------------------------------------------------------------------- */
function DragResize(myName, config) {
    //console.log("Drag resize obj: " + myName + ", " + config);

    var props = {
        myName: myName,
        enabled: true,
        handles: ['tl', 'tm', 'tr', 'ml', 'mr', 'bl', 'bm', 'br'],
        isElement: null,
        isHandle: null,
        getId: null,
        element: null,
        handle: null,
        minWidth: 10,
        minHeight: 10,
        minLeft: ScrLeft,
        maxLeft: ScrLeft + ScrWidth,
        minTop: ScrTop,
        maxTop: ScrTop + ScrHeight,
        zIndex: 1,
        mouseX: 0,
        mouseY: 0,
        lastMouseX: 0,
        lastMouseY: 0,
        mOffX: 0,
        mOffY: 0,
        elmX: 0,
        elmY: 0,
        elmW: 0,
        elmH: 0,
        allowBlur: true,
        ondragfocus: null,
        ondragstart: null,
        ondragmove: null,
        ondragend: null,
        ondragblur: null
    };
    for (var p in props)
        this[p] = (typeof config[p] == 'undefined') ? props[p] : config[p]
};

DragResize.prototype.apply = function (node) {
    var obj = this;
    addEvent(node, 'mousedown',
    function (e) {
        obj.mouseDown(e)
    });
    addEvent(node, 'mousemove',
    function (e) {
        obj.mouseMove(e)
    });
    addEvent(node, 'mouseup',
    function (e) {
        obj.mouseUp(e)
    })
};

DragResize.prototype.select = function (newElement) {
    with (this) {
        //scr window do nothing here
        if (!document.getElementById || !enabled) return;
        if (newElement && (newElement != element) && enabled) {
            element = newElement;

            if ((this.element.id.indexOf("vwscr") > -1) || this.element.id == "uniscr" || this.element.id == "mulscr" || this.element.id == "mulwin1")
            {
                //all scrwin don't process message
                return;
            }

            //select to highest zIndex
            element.style.zIndex = 100000; //make select window on top

            if (this.resizeHandleSet) this.resizeHandleSet(element, true);

            elmX = parseInt(element.style.left);
            elmY = parseInt(element.style.top);
            elmW = parseInt(element.style.width);//offsetWidth - 2; //seems dragresize has a 2 px board
            elmH = parseInt(element.style.height);//element.offsetHeight;

            if (ondragfocus) this.ondragfocus();

            //get winid
            var winid = this.element.id.split("n")[1];
            curwinid = parseInt(winid);
            element.style.background = selectcolor;

            mOffX = 0;
            mOffY = 0;            
        }
    }
};

DragResize.prototype.deselect = function (delHandles) {
    with (this) {
        if (!document.getElementById || !enabled)
            return;

        if (delHandles) {
            if (ondragblur)
                this.ondragblur();
            if (this.resizeHandleSet)
                this.resizeHandleSet(element, false);

            if (element) {
                element.style.background = unselcolor;      
            }

            element = null
        }
        else
        {
            //mouse up
        }

        handle = null;
        mOffX = 0;
        mOffY = 0

        //no sync window
        syncwinid = -1;
    }
};

//mouse down event handler
DragResize.prototype.mouseDown = function (e) {
    with (this) {
        if (!document.getElementById || !enabled) return true;
        var elm = e.target || e.srcElement,
        newElement = null,
        newHandle = null,
        hRE = new RegExp(myName + '-([trmbl]{2})', '');

        while (elm) {
            if (elm.className) {
                if (!newHandle && (hRE.test(elm.className) || isHandle(elm)))
                    newHandle = elm;
                if (isElement(elm)) {
                    newElement = elm;
                    break
                }
            }
            elm = elm.parentNode
        }

        if (newElement && ((newElement.id.indexOf("vwscr") > -1) || newElement.id == "uniscr" || newElement.id == "mulscr"))
        {
            //all scrwin don't process message
            return;
        }

        if (element && (element != newElement) && allowBlur)
            deselect(true);
        if (newElement && (!element || (newElement == element))) {
            if (newHandle)
                cancelEvent(e);
            select(newElement, newHandle);
            handle = newHandle;
            //if (handle && ondragstart)
            //    this.ondragstart(hRE.test(handle.className))
        }
    }
};

//mouse move event handler
DragResize.prototype.mouseMove = function (e) {

    with (this) {
        if (!document.getElementById || !enabled)
            return true;

        mouseX = e.pageX || e.clientX + document.documentElement.scrollLeft;
        mouseY = e.pageY || e.clientY + document.documentElement.scrollTop;
        
        var diffX = mouseX - lastMouseX + mOffX;
        var diffY = mouseY - lastMouseY + mOffY; 

        //console.log("mOffX="+mOffX+", mOffY="+mOffY);

        //ommit deltaX < 6 && deltaY < 6
   //     if (diffX < 6 && diffX > -6 && diffY < 6 && diffY > -6) return;

        if (diffX > 20) diffX = 20;
        if (diffX < -20) diffX = -20;
        if (diffY > 20) diffY = 20;
        if (diffY < -20) diffY = -20;
        
        mOffX = mOffY = 0;
        lastMouseX = mouseX;
        lastMouseY = mouseY;
        
        if (!handle)
            return true;

        if ((this.element.id.indexOf("vwscr") > -1) || this.element.id == "uniscr" || this.element.id == "mulscr" || this.element.id == "mulwin1")
        {
            //all scrwin don't process message
            return;
        }
        
        var isResize = false;

        if (this.resizeHandleDrag && this.resizeHandleDrag(diffX, diffY)) {
            isResize = true
        }
        else {
            //move window
            var dX = diffX, dY = diffY;
            if (elmX + dX < minLeft)
                mOffX = (dX - (diffX = minLeft - elmX));
            else if (elmX + elmW + dX > maxLeft)
                mOffX = (dX - (diffX = maxLeft - elmX - elmW));
            if (elmY + dY < minTop)
                mOffY = (dY - (diffY = minTop - elmY));
            else if (elmY + elmH + dY > maxTop)
                mOffY = (dY - (diffY = maxTop - elmY - elmH));

            elmX += diffX;
            elmY += diffY;          
        }

        with (element.style) {
            //window pos
            if (syncwinid != -1)
            {
                console.log("changed syncwin pos " + syncwinx0 + ", " + syncwinx1 + ", " + syncwiny0 + ", " + syncwiny1);
                elmX = syncwinx0;
                elmY = syncwiny0;
                elmW = syncwinx1 - syncwinx0 + 1;
                elmH = syncwiny1 - syncwiny0 + 1;

                console.log("changed elm pos " + elmX + ", " + elmY + ", " + elmW + "," + elmH);

                syncwinid = -1;
            }

            left   = elmX + 'px';
            width  = elmW + 'px';
            top    = elmY + 'px';
            height = elmH + 'px';
            //console.log("element.style win("+width+"," + height+")");      
        }

        if (window.opera && document.documentElement) {
            var oDF = document.getElementById('op-drag-fix');
            if (!oDF) {
                var oDF = document.createElement('input');
                oDF.id = 'op-drag-fix';
                oDF.style.display = 'none';
                document.body.appendChild(oDF)
            }
            oDF.focus()
        }
        if (ondragmove) this.ondragmove(isResize);
        cancelEvent(e)
    }

    var winid = this.element.id.split("n")[1];
    var x0, y0, x1, y1;
    var wWidth;
    var wHeight;

    if (usermode == 0) //video wall
    {
        wWidth = vwidth;
        wHeight = vheight;
    }
    else if (usermode == 1)
    {
        wWidth = uwidth;
        wHeight = uheight;
    }

    x0 = parseInt(parseInt(this.element.style.left) * wWidth / ScrWidth);
    y0 = parseInt(parseInt(this.element.style.top) * wHeight / ScrHeight);
    x1 = parseInt((parseInt(this.element.style.left) + parseInt(this.element.style.width)) * wWidth / ScrWidth);
    y1 = parseInt((parseInt(this.element.style.top) + parseInt(this.element.style.height)) * wHeight / ScrHeight);

    if (x0 < 0) x0 = 0;
    if (y0 < 0) y0 = 0;
    if (x1 > wWidth) x1 = wWidth - 1;
    if (y1 > wHeight) y1 = wHeight - 1;

    //console.log("mouseMove new! " + x0 + " " + x1 + " " + y0 + " " + y1);
    //console.log("mouseMove old! " + curwinx0 + " " + curwinx1 + " " + curwiny0 + " " + curwiny1);

    var movewinx0 = 0;
    var movewiny0 = 0;
    var movewinx1 = 0;
    var movewiny1 = 0;

    if (curwinx0 != -1 && curwinx0 != -1 && curwiny0 != -1 && curwiny1 != -1)
    {
        //pos delta value
        movewinx0 = x0 - curwinx0;
        movewinx1 = x1 - curwinx1; 
        movewiny0 = y0 - curwiny0;
        movewiny1 = y1 - curwiny1;
    }
    else
    {
        //no move
    }

    if (movewinx0 > -6 &&
        movewinx0 < 6 &&
        movewiny0 > -6 &&
        movewiny0 < 6 &&
        movewinx1 > -6 &&
        movewinx1 < 6 &&
        movewiny1 > -6 &&
        movewiny1 < 6)
    {
        return;
    }
    else
    {
        iswindowchanged = true;
    }

    curwinid = parseInt(winid) - 1;
    curwinx0 = x0;
    curwinx1 = x1;
    curwiny0 = y0;
    curwiny1 = y1;   
};

var curelement;
function set_vs_win_params(obj)
{
    if (curelement)
    {
        //change the status of this window
        var wscmd = "";
        var winid = 0;

        if (usermode == 0) //video wall
        { 
            wscmd += "config set vs win params ";
            winid = parseInt(obj.id.split("n")[1]);
        }
        else if (usermode == 1)
        {
            wscmd += "config set unicast win params ";
            winid = parseInt(obj.id.split("n")[2]);
            winid = winid + unicurindex * 5;
            console.log("unicurindex is " + unicurindex);
        }

        var left, top, right, bottom;

        left   = parseInt(obj.style.left) - ScrLeft;
        top    = parseInt(obj.style.top) - ScrTop;
        right  = (parseInt(obj.style.left) + parseInt(obj.style.width) - 1) - ScrLeft;
        bottom = (parseInt(obj.style.top) + parseInt(obj.style.height) - 1) - ScrTop;

        console.log("set_vs_win_params! pos("+ left + ", " + top + ", " + right + ", " + bottom + ")");
        
        if (usermode == 0) //video wall
        {
            left   = parseInt(left * vwidth / ScrWidth);
            top    = parseInt(top * vheight / ScrHeight);
            right  = parseInt(right * vwidth / ScrWidth);
            bottom = parseInt(bottom * vheight / ScrHeight);
        }
        else if (usermode == 1)
        {
            left   = parseInt(left * uwidth / ScrWidth);
            top    = parseInt(top * uheight / ScrHeight);
            right  = parseInt(right * uwidth / ScrWidth);
            bottom = parseInt(bottom * uheight / ScrHeight);            
        }

        if (left < 0) left = 0;
        if (top < 0) top = 0;

        if (usermode == 0)
        {
            if (right >= vwidth) right = vwidth - 1;
            if (bottom >= vheight) bottom = vheight - 1;
        }
        else if (usermode == 1)
        {
            if (right >= uwidth) right = uwidth - 1;
            if (bottom >= uheight) bottom = uheight - 1;            
        }

        //console.log("set_vs_win_params! old("+ curwinx0 + ", " + curwiny0 + ", " + curwinx1 + ", " + curwiny1 + ")");
        
        if ((curwinid == parseInt(winid) - 1) && 
            (iswindowchanged == false))
        {
            if (ws)
            {
                if(clearRXSelect == 1) {
                    if (usermode == 2)
                    {
                        wscmd = "config set clear multicast screen tx params";
                        wscmd += ";config get multicast win params";
                    }
                }
			
                ws.doSend(wscmd);
                console.log(wscmd);
            }
            //might not real moving behavior, quit
            //console.log("ommit mouse up!");
            return;
        }
        iswindowchanged = false;

        curwinid = parseInt(winid) - 1;
        curwinx0 = left;
        curwinx1 = right;
        curwiny0 = top;
        curwiny1 = bottom;

        wscmd += curwinid;
        wscmd += " ";
        wscmd += curwinx0;
        wscmd += " ";
        wscmd += curwinx1;
        wscmd += " ";
        wscmd += curwiny0;
        wscmd += " ";
        wscmd += curwiny1;

        if (ws)
        {
            if(clearRXSelect == 1) {
                if (usermode == 0) //video wall
                { 
                    wscmd += ";config set vs url params ";
                    wscmd += curwinid;
                    wscmd += " esource CLEAR 0;";
                    wscmd += ";config get vs win params ";
                    wscmd += curwinid;
                }
                else if (usermode == 1)
                {
                    wscmd += ";config set unicast url params ";
                    wscmd += curwinid;
                    wscmd += " esource CLEAR 0;";
                    wscmd += ";config get unicast win params ";
                    wscmd += curwinid;
                }
                else if (usermode == 2)
                {
                    wscmd += ";config set clear multicast screen tx params";
                    wscmd += ";config get multicast win params";
                }
            }

            ws.doSend(wscmd);
            console.log(wscmd);
        }
    }
}

var mouseupProc = function() {
  //mouse up first, dbclick second
  set_vs_win_params(curelement);
}

var timerid = setTimeout(mouseupProc, 100);
clearTimeout(timerid);

//mouse up
//if window size or pos changed, then send command to server!
DragResize.prototype.mouseUp = function (e) {
    with (this) {
        processed = false;

        if (!document.getElementById || !enabled)
            return;
        var hRE = new RegExp(myName + '-([trmbl]{2})', '');

        if (handle && ondragend) this.ondragend(hRE.test(handle.className));
        
        deselect(false);
    }

    //if (winchanged == 1)
    curelement = this.element;

    clearTimeout(timerid);
    timerid = setTimeout(mouseupProc, 300);

    //console.log("mouse up!!!!!!");  
};

DragResize.prototype.resizeHandleSet = function (elm, show) {
    with (this) {
        if (!elm._handle_tr) {
            for (var h = 0; h < handles.length; h++) {
                var hDiv = document.createElement('div');
                hDiv.className = myName + ' ' + myName + '-' + handles[h];
                elm['_handle_' + handles[h]] = elm.appendChild(hDiv)
            }
        }
        for (var h = 0; h < handles.length; h++) {
            elm['_handle_' + handles[h]].style.visibility = show ? 'inherit' : 'hidden'
        }
    }
};

//change window size!
DragResize.prototype.resizeHandleDrag = function (diffX, diffY) {
    with (this) {
        var hClass = handle && handle.className && handle.className.match(new RegExp(myName + '-([tmblr]{2})')) ? RegExp.$1 : '';
        var dY = diffY,
        dX = diffX,
        processed = false;

        if (hClass.indexOf('t') >= 0) {
            rs = 1;
            if (elmH - dY < minHeight) mOffY = (dY - (diffY = elmH - minHeight));
            else if (elmY + dY < minTop) mOffY = (dY - (diffY = minTop - elmY));
            elmY += diffY;
            elmH -= diffY;
            processed = true
        }
        if (hClass.indexOf('b') >= 0) {
            rs = 1;
            if (elmH + dY < minHeight) mOffY = (dY - (diffY = minHeight - elmH));
            else if (elmY + elmH + dY > maxTop) mOffY = (dY - (diffY = maxTop - elmY - elmH));
            elmH += diffY;
            processed = true
        }
        if (hClass.indexOf('l') >= 0) {
            rs = 1;
            if (elmW - dX < minWidth) mOffX = (dX - (diffX = elmW - minWidth));
            else if (elmX + dX < minLeft) mOffX = (dX - (diffX = minLeft - elmX));
            elmX += diffX;
            elmW -= diffX;
            processed = true
        }
        if (hClass.indexOf('r') >= 0) {
            rs = 1;
            if (elmW + dX < minWidth) mOffX = (dX - (diffX = minWidth - elmW));
            else if (elmX + elmW + dX > maxLeft) mOffX = (dX - (diffX = maxLeft - elmX - elmW));
            elmW += diffX;
            processed = true
        }

        return processed
    }
};
